diff --git a/src/core/ipv6/dhcp6.c b/src/core/ipv6/dhcp6.c
index e6a7e64d..fbf7621b 100644
--- a/src/core/ipv6/dhcp6.c
+++ b/src/core/ipv6/dhcp6.c
@@ -702,6 +1353,7 @@ dhcp6_recv(void *arg, struct udp_pcb *pcb, struct pbuf *p, const ip_addr_t *addr
   struct dhcp6_msg *reply_msg = (struct dhcp6_msg *)p->payload;
   u8_t msg_type;
   u32_t xid;
+  const u16_t opt_offset = sizeof(struct dhcp6_msg);
 
   LWIP_UNUSED_ARG(arg);
 
@@ -712,10 +1364,8 @@ dhcp6_recv(void *arg, struct udp_pcb *pcb, struct pbuf *p, const ip_addr_t *addr
 
   LWIP_ERROR("invalid server address type", IP_IS_V6(addr), goto free_pbuf_and_return;);
 
-  LWIP_DEBUGF(DHCP6_DEBUG | LWIP_DBG_TRACE, ("dhcp6_recv(pbuf = %p) from DHCPv6 server %s port %"U16_F"\n", (void *)p,
-    ipaddr_ntoa(addr), port));
-  LWIP_DEBUGF(DHCP6_DEBUG | LWIP_DBG_TRACE, ("pbuf->len = %"U16_F"\n", p->len));
-  LWIP_DEBUGF(DHCP6_DEBUG | LWIP_DBG_TRACE, ("pbuf->tot_len = %"U16_F"\n", p->tot_len));
+  LWIP_DEBUGF(DHCP6_DEBUG | LWIP_DBG_TRACE,("dhcp6_recv(pbuf=%p len=%"U16_F", tot_len=%"U16_F") from DHCPv6 srv %s\n",
+                                            (void *)p, p->len, p->tot_len, ipaddr_ntoa(addr)));
   /* prevent warnings about unused arguments */
   LWIP_UNUSED_ARG(pcb);
   LWIP_UNUSED_ARG(addr);
@@ -735,36 +1385,169 @@ dhcp6_recv(void *arg, struct udp_pcb *pcb, struct pbuf *p, const ip_addr_t *addr
                 ("transaction id mismatch reply_msg->xid(%"X32_F")!= dhcp6->xid(%"X32_F")\n", xid, dhcp6->xid));
     goto free_pbuf_and_return;
   }
-  /* option fields could be unfold? */
-  if (dhcp6_parse_reply(p, dhcp6) != ERR_OK) {
-    LWIP_DEBUGF(DHCP6_DEBUG | LWIP_DBG_TRACE | LWIP_DBG_LEVEL_SERIOUS,
-                ("problem unfolding DHCPv6 message - too short on memory?\n"));
-    goto free_pbuf_and_return;
-  }
 
   /* read DHCP message type */
   msg_type = reply_msg->msgtype;
   /* message type is DHCP6 REPLY? */
-  if (msg_type == DHCP6_REPLY) {
-    LWIP_DEBUGF(DHCP6_DEBUG | LWIP_DBG_TRACE, ("DHCP6_REPLY received\n"));
+  switch (msg_type) {
+    case DHCP6_REPLY:
+      LWIP_DEBUGF(DHCP6_DEBUG | LWIP_DBG_TRACE, ("DHCP6_REPLY received\n"));
 #if LWIP_IPV6_DHCP6_STATELESS
-    /* in info-requesting state? */
-    if (dhcp6->state == DHCP6_STATE_REQUESTING_CONFIG) {
-      dhcp6_set_state(dhcp6, DHCP6_STATE_STATELESS_IDLE, "dhcp6_recv");
-      dhcp6_handle_config_reply(netif, p);
-    } else
+      /* in info-requesting state? */
+      switch (dhcp6->state) {
+        case DHCP6_STATE_SL_REQUESTING_CONFIG:
+#if LWIP_DHCP6_PROVIDE_DNS_SERVERS
+          dhcp6_parse_dns_servers(netif, p, opt_offset);
+#endif
+#if LWIP_DHCP6_GET_NTP_SRV
+          dhcp6_parse_sntp_servers(netif, p, opt_offset);
+#endif /* LWIP_DHCP6_PROVIDE_DNS_SERVERS */
+#ifdef LWIP_HOOK_DHCP6_PARSE_ORO_OPTS_CUSTOM
+          dhcp6_parse_oro_opts_custom(netif, dhcp6, p, opt_offset);
+#endif
+          dhcp6_set_state(netif, dhcp6, DHCP6_STATE_IDLE, "dhcp6_recv");
+          break;
 #endif /* LWIP_IPV6_DHCP6_STATELESS */
-    {
-      /* @todo: handle reply in other states? */
-    }
-  } else {
-    /* @todo: handle other message types */
-  }
+#if LWIP_IPV6_DHCP6_STATEFUL
+        case DHCP6_STATE_SF_RENEWING:
+        case DHCP6_STATE_SF_REQUESTING: {
+          u8_t success;
+          u8_t refused_by_srv = 0;
+          if (dhcp6_parse_and_check_serverid_different(p, opt_offset, dhcp6)) {
+            LWIP_DEBUGF(DHCP6_DEBUG | LWIP_DBG_TRACE | LWIP_DBG_LEVEL_WARNING,
+                        ("DHCPv6 reply has different server ID. Ignoring.\n"));
+            break; /* reply is not for us */
+          }
+#if LWIP_IPV6_DHCP6_PD
+          success = dhcp6_parse_ia_pd(p, opt_offset, dhcp6);
+          if (!success) {
+            set_prefix_not_delegated(dhcp6);
+            LWIP_DEBUGF(DHCP6_DEBUG | LWIP_DBG_TRACE, ("Using DHCPv6 advertisement without prefix.\n"));
+          } else {
+            refused_by_srv = (dhcp6->prefix.prefix_valid == 0);
+            if (refused_by_srv) {
+              LWIP_DEBUGF(DHCP6_DEBUG | LWIP_DBG_TRACE, ("DHCPv6 srv revoked delegated prefix (valid time is zero).\n"));
+            }
+          }
+#endif /* LWIP_IPV6_DHCP6_PD */
+
+#if LWIP_DHCP6_PROVIDE_DNS_SERVERS
+          dhcp6_parse_dns_servers(netif, p, opt_offset);
+#endif
+#if LWIP_DHCP6_GET_NTP_SRV
+          dhcp6_parse_sntp_servers(netif, p, opt_offset);
+#endif
+#ifdef LWIP_HOOK_DHCP6_PARSE_ORO_OPTS_CUSTOM
+          dhcp6_parse_oro_opts_custom(netif, dhcp6, p, opt_offset);
+#endif
+
+          if (!dhcp6->addr_by_slaac) {
+            success = dhcp6_parse_ia_na(p, opt_offset, dhcp6);
+            if (!success) {
+              set_addr_not_advertised(dhcp6);
+            } else {
+              LWIP_DEBUGF(DHCP6_DEBUG | LWIP_DBG_TRACE, ("Using DHCPv6 advertisement without address\n"));
+              netif_add_ip6_address(netif, &dhcp6->addr, &dhcp6->addr_idx);
+              if (dhcp6->addr_idx >= 0) {
+                netif_ip6_addr_set_pref_life(netif, dhcp6->addr_idx, dhcp6->addr_pref);
+                netif_ip6_addr_set_valid_life(netif, dhcp6->addr_idx, dhcp6->addr_valid);
+                if (dhcp6->addr_valid <= 0) {
+                  /* Server is refusing our renew request. */
+                  refused_by_srv = 1;
+                  netif_ip6_addr_set_state(netif, dhcp6->addr_idx, IP6_ADDR_INVALID);
+                } else if (ip6_addr_isvalid(netif_ip6_addr_state(netif, 1))) {
+                  netif_ip6_addr_set_state(netif, dhcp6->addr_idx, IP6_ADDR_PREFERRED);
+                } else {
+                  netif_ip6_addr_set_state(netif, dhcp6->addr_idx, IP6_ADDR_TENTATIVE);
+                }
+              } else {
+                LWIP_ASSERT("Not enough space for IPv6 add from DHCP.", dhcp6->addr_idx < 0);
+              }
+            }
+          } else {
+            set_addr_not_advertised(dhcp6);
+          }
+#if LWIP_IPV6_DHCP6_PD
+          if (dhcp6->pd_callback != NULL) {
+            dhcp6->pd_callback(netif, &dhcp6->prefix, (dhcp6->prefix.prefix_valid > 0));
+          }
+
+          /*dhcp6_set_state(netif, dhcp6, valid ? DHCP6_STATE_SF_BOUND, "dhcp6_recv"); toto nejak vykut - potrebujeme se dostat do soliciting pokud jakykoliv valid time = 0 a
+          a zahlasit to callbackem o prefixu.*/
+
+#endif /* LWIP_IPV6_DHCP6_PD */
+          dhcp6_set_state(netif, dhcp6, refused_by_srv ? DHCP6_STATE_SF_SOLICITING : DHCP6_STATE_SF_BOUND, "dhcp6_recv");
+          break;
+        } /* case DHCP6_STATE_SF_REQUESTING */
+
+        case DHCP6_STATE_SF_RELEASING:
+          if (dhcp6_parse_and_check_serverid_different(p, opt_offset, dhcp6)) {
+            LWIP_DEBUGF(DHCP6_DEBUG | LWIP_DBG_TRACE | LWIP_DBG_LEVEL_WARNING,
+                        ("Ignoring reply with different server ID.\n"));
+            break; /* reply is not for us */
+          }
+          dhcp6_set_state(netif, dhcp6, DHCP6_STATE_OFF, "dhcp6_recv");
+
+#endif /* LWIP_IPV6_DHCP6_STATEFUL */
+
+        default:
+          break;
+      } /* switch (dhcp6->state) */
+
+      break;
+
+#if LWIP_IPV6_DHCP6_STATEFUL
+    case DHCP6_ADVERTISE:
+      if (dhcp6->state == DHCP6_STATE_SF_SOLICITING) {
+        /* TODO handle rapid commit option, handle preference option, seek for the best server. */
+        int success = dhcp6_parse_and_store_serverid(p, opt_offset, dhcp6);
+        if (!success) {
+          LWIP_DEBUGF(DHCP6_DEBUG | LWIP_DBG_LEVEL_WARNING, ("DHCP6_ADVERTISE without server id\n"));
+          dhcp6_set_state(netif, dhcp6, DHCP6_STATE_SF_SOLICITING, "dhcp6_recv");
+          break;
+        }
+
+#if LWIP_IPV6_DHCP6_PD
+        success = dhcp6_parse_ia_pd(p, opt_offset, dhcp6);
+        if (!success) {
+          set_prefix_not_delegated(dhcp6);
+          LWIP_DEBUGF(DHCP6_DEBUG | LWIP_DBG_TRACE, ("Using dhcp6 advertisement without prefix\n"));
+        }
+#endif /* LWIP_IPV6_DHCP6_PD */
+
+        if (!dhcp6->addr_by_slaac) {
+          success = dhcp6_parse_ia_na(p, opt_offset, dhcp6);
+          if (!success) {
+            set_addr_not_advertised(dhcp6);
+            LWIP_DEBUGF(DHCP6_DEBUG | LWIP_DBG_TRACE, ("Using dhcp6 advertisement without address\n"));
+          }
+        } else {
+          set_addr_not_advertised(dhcp6);
+        }
+        dhcp6_set_state(netif, dhcp6, DHCP6_STATE_SF_REQUESTING, "dhcp6_recv");
+      }
+      break;
+#endif /* LWIP_IPV6_DHCP6_STATEFUL */
+
+    default:
+      break;
+
+  } /* switch (msg_type) */
 
 free_pbuf_and_return:
   pbuf_free(p);
 }
 
+static void
+dhcp6_update_retrans_timeout(struct dhcp6 *dhcp6)
+{
+  dhcp6->request_timeout *= 2;
+  if (dhcp6->request_timeout > dhcp6->max_request_timeout) {
+    dhcp6->request_timeout = dhcp6->max_request_timeout;
+  }
+  dhcp6->request_timeout_cntr = dhcp6->request_timeout;
+}
+
 /**
  * A DHCPv6 request has timed out.
  *
@@ -779,15 +1562,141 @@ dhcp6_timeout(struct netif *netif, struct dhcp6 *dhcp6)
   LWIP_UNUSED_ARG(netif);
   LWIP_UNUSED_ARG(dhcp6);
 
-#if LWIP_IPV6_DHCP6_STATELESS
-  /* back-off period has passed, or server selection timed out */
-  if (dhcp6->state == DHCP6_STATE_REQUESTING_CONFIG) {
-    LWIP_DEBUGF(DHCP6_DEBUG | LWIP_DBG_TRACE, ("dhcp6_timeout(): retrying information request\n"));
-    dhcp6_information_request(netif, dhcp6);
+  switch (dhcp6->state) {
+
+    case DHCP6_STATE_OFF:
+    case DHCP6_STATE_IDLE:
+      break;
+    case DHCP6_STATE_SL_REQUESTING_CONFIG:
+      LWIP_DEBUGF(DHCP6_DEBUG | LWIP_DBG_TRACE, ("dhcp6_timeout: retrying information request\n"));
+      dhcp6_information_request(netif, dhcp6);
+      break;
+#if LWIP_IPV6_DHCP6_STATEFUL
+    case DHCP6_STATE_SF_INIT_DELAY:
+      dhcp6_set_state(netif, dhcp6, DHCP6_STATE_SF_SOLICITING, "dhcp6_timeout from INIT_DELAY");
+      break;
+    case DHCP6_STATE_SF_SOLICITING:
+      LWIP_DEBUGF(DHCP6_DEBUG | LWIP_DBG_TRACE, ("dhcp6_timeout: retrying solicitation\n"));
+      dhcp6_solicitation(netif, dhcp6);
+      break;
+    case DHCP6_STATE_SF_REQUESTING:
+      if (dhcp6->tries >= dhcp6->max_retrans_cnt) {
+        dhcp6_set_state(netif, dhcp6, DHCP6_STATE_SF_SOLICITING, "dhcp6_timeout from REQUESTING");
+      } else {
+        LWIP_DEBUGF(DHCP6_DEBUG | LWIP_DBG_TRACE, ("dhcp6_timeout: retrying request\n"));
+        dhcp6_request(netif, dhcp6);
+      }
+      break;
+
+    case DHCP6_STATE_SF_BOUND:
+      break;
+
+    case DHCP6_STATE_SF_RENEWING:
+      LWIP_DEBUGF(DHCP6_DEBUG | LWIP_DBG_TRACE, ("dhcp6_timeout: retrying renew request\n"));
+      dhcp6_renew(netif, dhcp6);
+      break;
+    case DHCP6_STATE_SF_REBINDING:
+      dhcp6_rebind(netif, dhcp6);
+      break;
+    case DHCP6_STATE_SF_RELEASING:
+      if (dhcp6->tries >= dhcp6->max_retrans_cnt) {
+        dhcp6_set_state(netif, dhcp6, DHCP6_STATE_OFF, "dhcp6_timeout from RELEASING");
+      } else {
+        LWIP_DEBUGF(DHCP6_DEBUG | LWIP_DBG_TRACE, ("dhcp6_timeout: retrying release request\n"));
+        dhcp6_release(netif, dhcp6);
+      }
+      break;
+#endif /* LWIP_IPV6_DHCP6_STATEFUL */
+    default:
+      LWIP_ASSERT("Unhandled state in dhcp6_timeout", 0);
   }
-#endif /* LWIP_IPV6_DHCP6_STATELESS */
+
+  dhcp6_update_retrans_timeout(dhcp6);
+
+/*#endif  LWIP_IPV6_DHCP6_STATELESS */
 }
 
+#if LWIP_IPV6_DHCP6_STATEFUL
+static void
+dhcp6_1s_tick(struct netif * netif, struct dhcp6 *dhcp6) {
+
+  switch (dhcp6->state) {
+    case DHCP6_STATE_SF_BOUND:
+
+#if LWIP_IPV6_DHCP6_PD
+      if (!is_prefix_advertised(dhcp6)) {
+        /* nothing to do */
+      }
+      else if (dhcp6->prefix.prefix_pref == 1) {
+        dhcp6->prefix.prefix_pref = 0;
+        /* Valid time of prefix expired */
+        dhcp6_set_state(netif, dhcp6, DHCP6_STATE_SF_RENEWING, "dhcp6_1s_tick");
+        break;
+      } else if (dhcp6->prefix.prefix_pref > 0) {
+        dhcp6->prefix.prefix_pref--;
+      }
+#endif /* LWIP_IPV6_DHCP6_PD */
+
+      if (is_addr_advertised(dhcp6)) {
+        if (dhcp6->addr_t1 == 1) {
+          dhcp6->addr_t1 = 0;
+          /* Valid time of prefix expired */
+          dhcp6_set_state(netif, dhcp6, DHCP6_STATE_SF_RENEWING, "dhcp6_1s_tick");
+          break;
+        } else if (dhcp6->addr_t1 > 0) {
+          dhcp6->addr_t1--;
+        }
+
+        if (netif_ip6_addr_pref_life(netif, dhcp6->addr_idx) == 0) {
+          dhcp6_set_state(netif, dhcp6, DHCP6_STATE_SF_RENEWING, "dhcp6_1s_tick");
+          break;
+        }
+      }
+
+      /* Intentional fall through */
+
+    case DHCP6_STATE_SF_RENEWING:
+#if LWIP_IPV6_DHCP6_PD
+      if (!is_prefix_advertised(dhcp6)) {
+        /* nothing to do */
+      }
+      else if (dhcp6->prefix.prefix_valid == 1) {
+        dhcp6->prefix.prefix_valid = 0;
+        /* Valid time of prefix expired */
+        if (dhcp6->pd_callback != NULL) {
+          dhcp6->pd_callback(netif, &dhcp6->prefix, 0);
+        }
+        dhcp6_set_state(netif, dhcp6, DHCP6_STATE_SF_SOLICITING, "dhcp6_1s_tick");
+        break;
+      } else if (dhcp6->prefix.prefix_valid > 0) {
+        dhcp6->prefix.prefix_valid--;
+      }
+#endif /* LWIP_IPV6_DHCP6_PD */
+
+      if (is_addr_advertised(dhcp6)) {
+        if (dhcp6->addr_t2 == 1) {
+          dhcp6->addr_t2 = 0;
+          /* Valid time of prefix expired */
+          dhcp6_set_state(netif, dhcp6, DHCP6_STATE_SF_RENEWING, "dhcp6_1s_tick");
+          break;
+        } else if (dhcp6->addr_t2 > 0) {
+          dhcp6->addr_t2--;
+        }
+
+        if (netif_ip6_addr_valid_life(netif, dhcp6->addr_idx) == 0) {
+          dhcp6_set_state(netif, dhcp6, DHCP6_STATE_SF_SOLICITING, "dhcp6_1s_tick");
+          break;
+        }
+      }
+      break;
+
+    default:
+      break;
+  }
+}
+#endif /* LWIP_IPV6_DHCP6_STATEFUL */
+
+
 /**
  * DHCPv6 timeout handling (this function must be called every 500ms,
  * see @ref DHCP6_TIMER_MSECS).
@@ -799,23 +1708,41 @@ void
 dhcp6_tmr(void)
 {
   struct netif *netif;
+
+#if LWIP_IPV6_DHCP6_STATEFUL
+  u8_t second_elapsed = 0;
+  static u16_t ticks_ms = 0;
+  if (ticks_ms >= 1000) {
+    ticks_ms -= 1000;
+    second_elapsed = 1;
+  }
+  ticks_ms += DHCP6_TIMER_MSECS;
+#endif /* LWIP_IPV6_DHCP6_STATEFUL */
+
   /* loop through netif's */
   NETIF_FOREACH(netif) {
     struct dhcp6 *dhcp6 = netif_dhcp6_data(netif);
     /* only act on DHCPv6 configured interfaces */
     if (dhcp6 != NULL) {
-      /* timer is active (non zero), and is about to trigger now */
-      if (dhcp6->request_timeout > 1) {
-        dhcp6->request_timeout--;
-      } else if (dhcp6->request_timeout == 1) {
-        dhcp6->request_timeout--;
+#if LWIP_IPV6_DHCP6_STATEFUL
+      if (second_elapsed) {
+        dhcp6_1s_tick(netif, dhcp6);
+      }
+#endif
+
+      /* timer is active (non-zero), and is about to trigger now */
+      if (dhcp6->request_timeout_cntr > 1) {
+        dhcp6->request_timeout_cntr--;
+      } else if (dhcp6->request_timeout_cntr == 1) {
+        dhcp6->request_timeout_cntr--;
         /* { dhcp6->request_timeout == 0 } */
-        LWIP_DEBUGF(DHCP6_DEBUG | LWIP_DBG_TRACE | LWIP_DBG_STATE, ("dhcp6_tmr(): request timeout\n"));
+        LWIP_DEBUGF(DHCP6_DEBUG | LWIP_DBG_TRACE, ("dhcp6_tmr: request timeout\n"));
         /* this client's request timeout triggered */
         dhcp6_timeout(netif, dhcp6);
       }
     }
-  }
+  } /* NETIF_FOREACH() */
 }
 
+
 #endif /* LWIP_IPV6 && LWIP_IPV6_DHCP6 */
diff --git a/src/include/lwip/dhcp6.h b/src/include/lwip/dhcp6.h
index 5cc4a015..71031b98 100644
--- a/src/include/lwip/dhcp6.h
+++ b/src/include/lwip/dhcp6.h
@@ -8,6 +8,7 @@
 
 /*
  * Copyright (c) 2018 Simon Goldschmidt
+ * Copyright 2023 NXP
  * All rights reserved.
  *
  * Redistribution and use in source and binary forms, with or without modification,
@@ -54,6 +55,24 @@ extern "C" {
 /** period (in milliseconds) of the application calling dhcp6_tmr() */
 #define DHCP6_TIMER_MSECS   500
 
+#if LWIP_IPV6_DHCP6_STATEFUL
+void dhcp6_set_client_id_duid(struct netif *netif, const void *duid, u16_t duid_len);
+#endif
+
+#if LWIP_IPV6_DHCP6_PD
+struct dhcp6_delegated_prefix
+{
+  ip6_addr_t prefix;
+  u8_t prefix_len;
+  u32_t prefix_pref; /* Prefix preferred lifetime [s] */
+  u32_t prefix_valid; /* Prefix valid lifetime [s] */
+};
+
+typedef void (*dhcp6_pd_callback_fn)(struct netif * netif, const struct dhcp6_delegated_prefix * prefix, u8_t valid);
+void dhcp6_register_pd_callback(struct netif *netif, dhcp6_pd_callback_fn callback);
+const struct dhcp6_delegated_prefix * dhcp6_get_delegated_prefix(struct netif * netif);
+#endif
+
 struct dhcp6
 {
   /** transaction identifier of last sent request */
@@ -62,15 +81,48 @@ struct dhcp6
   u8_t pcb_allocated;
   /** current DHCPv6 state machine state */
   u8_t state;
+  /** State after releasing of address is done */
+  u8_t state_after_release;
   /** retries of current request */
   u8_t tries;
-  /** if request config is triggered while another action is active, this keeps track of it */
-  u8_t request_config_pending;
   /** #ticks with period DHCP6_TIMER_MSECS for request timeout */
+  u16_t request_timeout_cntr;
   u16_t request_timeout;
+
+  /** upper bound of request timeout in #ticks */
+  u16_t max_request_timeout;
+
 #if LWIP_IPV6_DHCP6_STATEFUL
-  /* @todo: add more members here to keep track of stateful DHCPv6 data, like lease times */
+  /** Maximal count of retransmissions */
+  u8_t max_retrans_cnt;
+    /** Maximal duration of retransmissions */
+  u16_t max_retrans_dur;
+
+  u32_t trans_started_at;
+  void *server_id; /* Dynamically allocated mem with server id including its option header */
+  u8_t server_id_len; /* Length of server id including its option header */
+
+  const void *cli_id_usr_duid; /* Client ID DUID supplied by user */
+  u16_t cli_id_usr_duid_len; /* Lenght of client ID DUID supplied by user */
+
+  ip6_addr_t addr;
+  s8_t  addr_idx;
+  u32_t addr_pref;
+  u32_t addr_valid;
+  u32_t addr_t1;
+  u32_t addr_t2;
+
+  u8_t addr_by_slaac;
+
 #endif /* LWIP_IPV6_DHCP6_STATEFUL */
+
+#if LWIP_IPV6_DHCP6_PD
+  struct dhcp6_delegated_prefix prefix;
+  u32_t ia_pd_t1;
+  u32_t ia_pd_t2;
+
+  dhcp6_pd_callback_fn pd_callback;
+#endif /* LWIP_IPV6_DHCP6_PD  */
 };
 
 void dhcp6_set_struct(struct netif *netif, struct dhcp6 *dhcp6);
@@ -78,8 +130,7 @@ void dhcp6_set_struct(struct netif *netif, struct dhcp6 *dhcp6);
 #define dhcp6_remove_struct(netif) netif_set_client_data(netif, LWIP_NETIF_CLIENT_DATA_INDEX_DHCP6, NULL)
 void dhcp6_cleanup(struct netif *netif);
 
-err_t dhcp6_enable_stateful(struct netif *netif);
-err_t dhcp6_enable_stateless(struct netif *netif);
+err_t dhcp6_enable(struct netif *netif);
 void dhcp6_disable(struct netif *netif);
 
 void dhcp6_tmr(void);
diff --git a/src/include/lwip/prot/dhcp6.h b/src/include/lwip/prot/dhcp6.h
index 0754c91b..29ada921 100644
--- a/src/include/lwip/prot/dhcp6.h
+++ b/src/include/lwip/prot/dhcp6.h
@@ -5,6 +5,7 @@
 
 /*
  * Copyright (c) 2017 Simon Goldschmidt <goldsimon@gmx.de>
+ * Copyright 2023 NXP
  * All rights reserved.
  *
  * Redistribution and use in source and binary forms, with or without modification,
@@ -32,13 +33,16 @@
  * This file is part of the lwIP TCP/IP stack.
  *
  * Author: Simon Goldschmidt <goldsimon@gmx.de>
- *
  */
 #ifndef LWIP_HDR_PROT_DHCP6_H
 #define LWIP_HDR_PROT_DHCP6_H
 
 #include "lwip/opt.h"
 
+#if LWIP_IPV6_DHCP6_STATEFUL
+#include "lwip/ip6.h"
+#endif
+
 #ifdef __cplusplus
 extern "C" {
 #endif
@@ -66,12 +70,93 @@ PACK_STRUCT_END
 #  include "arch/epstruct.h"
 #endif
 
+#ifdef PACK_STRUCT_USE_INCLUDES
+#  include "arch/bpstruct.h"
+#endif
+PACK_STRUCT_BEGIN
+/** minimum set of fields of any DHCPv6 message */
+struct dhcp6_option_header
+{
+  PACK_STRUCT_FIELD(u16_t option_code);
+  PACK_STRUCT_FIELD(u16_t option_len);
+  /* options follow */
+} PACK_STRUCT_STRUCT;
+PACK_STRUCT_END
+#ifdef PACK_STRUCT_USE_INCLUDES
+#  include "arch/epstruct.h"
+#endif
+
+#if LWIP_IPV6_DHCP6_STATEFUL
+#ifdef PACK_STRUCT_USE_INCLUDES
+#  include "arch/bpstruct.h"
+#endif
+PACK_STRUCT_BEGIN
+struct dhcp6_option_ia_address
+{
+    PACK_STRUCT_FLD_S(ip6_addr_p_t address);
+    PACK_STRUCT_FIELD(u32_t preferred);
+    PACK_STRUCT_FIELD(u32_t valid);
+} PACK_STRUCT_STRUCT;
+PACK_STRUCT_END
+#ifdef PACK_STRUCT_USE_INCLUDES
+#  include "arch/epstruct.h"
+#endif
+#endif  /* LWIP_IPV6_DHCP6_STATEFUL */
+
+#if LWIP_IPV6_DHCP6_PD
+#ifdef PACK_STRUCT_USE_INCLUDES
+#  include "arch/bpstruct.h"
+#endif
+PACK_STRUCT_BEGIN
+/** minimum set of fields of any DHCPv6 message */
+struct dhcp6_option_ia_pd
+{
+  PACK_STRUCT_FIELD(u32_t preferred);
+  PACK_STRUCT_FIELD(u32_t valid);
+  PACK_STRUCT_FLD_8(u8_t prefix_length);
+  PACK_STRUCT_FLD_S(ip6_addr_p_t prefix);
+  /* options follows */
+} PACK_STRUCT_STRUCT;
+PACK_STRUCT_END
+#ifdef PACK_STRUCT_USE_INCLUDES
+#  include "arch/epstruct.h"
+#endif
+#endif /* LWIP_IPV6_DHCP6_PD */
+
+#ifdef PACK_STRUCT_USE_INCLUDES
+#  include "arch/bpstruct.h"
+#endif
+PACK_STRUCT_BEGIN
+/** minimum set of fields of any DHCPv6 message */
+struct dhcp6_option_ia /*TODO*/
+{
+  PACK_STRUCT_FIELD(u32_t ia_id);
+  PACK_STRUCT_FIELD(u32_t t1);
+  PACK_STRUCT_FIELD(u32_t t2);
+  /* options follow */
+} PACK_STRUCT_STRUCT;
+PACK_STRUCT_END
+#ifdef PACK_STRUCT_USE_INCLUDES
+#  include "arch/epstruct.h"
+#endif
+
 
 /* DHCP6 client states */
 typedef enum {
-  DHCP6_STATE_OFF               = 0,
-  DHCP6_STATE_STATELESS_IDLE    = 1,
-  DHCP6_STATE_REQUESTING_CONFIG = 2
+  DHCP6_STATE_OFF = 0,
+  DHCP6_STATE_IDLE,
+
+  DHCP6_STATE_STATELESS=64,
+  DHCP6_STATE_SL_REQUESTING_CONFIG,
+
+  DHCP6_STATE_STATEFULL=128,
+  DHCP6_STATE_SF_INIT_DELAY,
+  DHCP6_STATE_SF_SOLICITING,
+  DHCP6_STATE_SF_REQUESTING,
+  DHCP6_STATE_SF_BOUND,
+  DHCP6_STATE_SF_RENEWING,
+  DHCP6_STATE_SF_REBINDING,
+  DHCP6_STATE_SF_RELEASING
 } dhcp6_state_enum_t;
 
 /* DHCPv6 message types */
@@ -128,9 +213,37 @@ typedef enum {
 /* More options see https://www.iana.org/assignments/dhcpv6-parameters/dhcpv6-parameters.xhtml */
 #define DHCP6_OPTION_DNS_SERVERS    23 /* RFC 3646 */
 #define DHCP6_OPTION_DOMAIN_LIST    24 /* RFC 3646 */
+#define DHCP6_OPTION_IA_PD          25 /*	RFC3633 RFC8415 */
+#define DHCP6_OPTION_IAPREFIX       26 /*	RFC3633 RFC8415 */
 #define DHCP6_OPTION_SNTP_SERVERS   31 /* RFC 4075 */
 
 
+/* DHCP default parametters */
+#define DHCP6_PAR_SOL_MAX_DELAY     1 /*[s] Max delay of first Solicit */
+#define DHCP6_PAR_SOL_TIMEOUT       1 /*[s] Initial Solicit timeout */
+#define DHCP6_PAR_SOL_MAX_RT      120 /*[s] Max Solicit timeout value */
+#define DHCP6_PAR_REQ_TIMEOUT       1 /*[s] Initial Request timeout */
+#define DHCP6_PAR_REQ_MAX_RT       30 /*[s] Max Request timeout value */
+#define DHCP6_PAR_REQ_MAX_RC       10 /*    Max Request retry attempts */
+#define DHCP6_PAR_CNF_MAX_DELAY     1 /*[s] Max delay of first Confirm */
+#define DHCP6_PAR_CNF_TIMEOUT       1 /*[s] Initial Confirm timeout */
+#define DHCP6_PAR_CNF_MAX_RT        4 /*[s] Max Confirm timeout */
+#define DHCP6_PAR_CNF_MAX_RD       10 /*[s] Max Confirm duration */
+#define DHCP6_PAR_REN_TIMEOUT      10 /*[s] Initial Renew timeout */
+#define DHCP6_PAR_REN_MAX_RT      600 /*[s] Max Renew timeout value */
+#define DHCP6_PAR_REB_TIMEOUT      10 /*[s] Initial Rebind timeout */
+#define DHCP6_PAR_REB_MAX_RT      600 /*[s] Max Rebind timeout value */
+#define DHCP6_PAR_INF_MAX_DELAY     1 /*[s] Max delay of first Information-request */
+#define DHCP6_PAR_INF_TIMEOUT       1 /*[s] Initial Information-request timeout */
+#define DHCP6_PAR_INF_MAX_RT      120 /*[s] Max Information-request timeout value */
+#define DHCP6_PAR_REL_TIMEOUT       1 /*[s] Initial Release timeout */
+#define DHCP6_PAR_REL_MAX_RC        5 /*    MAX Release attempts */
+#define DHCP6_PAR_DEC_TIMEOUT       1 /*[s] Initial Decline timeout */
+#define DHCP6_PAR_DEC_MAX_RC        5 /*    Max Decline attempts */
+#define DHCP6_PAR_REC_TIMEOUT       2 /*[s] Initial Reconfigure timeout */
+#define DHCP6_PAR_REC_MAX_RC        8 /*    Max Reconfigure attempts */
+#define DHCP6_PAR_HOP_COUNT_LIMIT  32 /*    Max hop count in a Relay-forward message */
+
 #ifdef __cplusplus
 }
 #endif
diff --git a/test/unit/Filelists.cmake b/test/unit/Filelists.cmake
index b3db893c..cc513e16 100644
--- a/test/unit/Filelists.cmake
+++ b/test/unit/Filelists.cmake
@@ -24,6 +24,7 @@ set(LWIP_TESTFILES
 	${LWIP_TESTDIR}/core/test_pbuf.c
 	${LWIP_TESTDIR}/core/test_timers.c
 	${LWIP_TESTDIR}/dhcp/test_dhcp.c
+	${LWIP_TESTDIR}/dhcp6/test_dhcp6.c
 	${LWIP_TESTDIR}/etharp/test_etharp.c
 	${LWIP_TESTDIR}/ip4/test_ip4.c
 	${LWIP_TESTDIR}/ip6/test_ip6.c
diff --git a/test/unit/Filelists.mk b/test/unit/Filelists.mk
index c33e1b04..ce3b643a 100644
--- a/test/unit/Filelists.mk
+++ b/test/unit/Filelists.mk
@@ -40,6 +40,7 @@ TESTFILES=$(TESTDIR)/lwip_unittests.c \
 	$(TESTDIR)/core/test_pbuf.c \
 	$(TESTDIR)/core/test_timers.c \
 	$(TESTDIR)/dhcp/test_dhcp.c \
+	$(TESTDIR)/dhcp6/test_dhcp6.c \
 	$(TESTDIR)/etharp/test_etharp.c \
 	$(TESTDIR)/ip4/test_ip4.c \
 	$(TESTDIR)/ip6/test_ip6.c \
